﻿Public Class frm_MainView
    Public WithEvents tim_Ram As New System.Timers.Timer With {.Interval = 60000, .Enabled = True}
    Dim LastTextField As Control
    Dim SaveorNot As Boolean = False
    Private Sub tim_Ram_Elapsed(sender As Object, e As ElapsedEventArgs) Handles tim_Ram.Elapsed
        Extra.ReduceRam()
    End Sub
    Private Sub Form_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        If My.Settings.mainwidth <> 0 AndAlso My.Settings.mainheight <> 0 Then
            Me.Height = My.Settings.mainheight
            Me.Width = My.Settings.mainwidth
        End If
        'Basic
        Me.SetStyle(ControlStyles.OptimizedDoubleBuffer, True)
        Me.UpdateStyles()
        'Basic      
        If My.Settings.db_rootPath = "" Then
            ChoosePath()
        Else
            If IO.File.Exists(My.Settings.db_rootPath & "\hpdb.xml") Then
                ReadDB()
            End If
        End If
        bs_Categorys.Sort = "CategoryName ASC"
        bs_Categorys_Notes.Sort = "NoteName ASC"
    End Sub
    Private Sub Form_Closing(sender As Object, e As CancelEventArgs) Handles Me.Closing
        If File.Exists(My.Settings.db_rootPath & "\working.txt") Then
            File.Delete(My.Settings.db_rootPath & "\working.txt")
        End If
        WriteDB()
        My.Settings.Save()
    End Sub
    Private Sub frm_MainView_ResizeEnd(sender As Object, e As EventArgs) Handles Me.ResizeEnd
        My.Settings.mainheight = Me.Height
        My.Settings.mainwidth = Me.Width
    End Sub
    Private Sub ReadDB()
        If IO.File.Exists(My.Settings.db_rootPath & "\hpdb.xml") Then
            Dim LastCategory As Integer
            Dim LastNote As Integer
            If bs_Categorys.Count > 0 Then
                LastCategory = bs_Categorys.Position
                If bs_Categorys_Notes.Count > 0 Then
                    LastNote = bs_Categorys_Notes.Position
                End If
            End If
            Ds_HelpDeskNotes.Clear()
            Ds_HelpDeskNotes.ReadXml(My.Settings.db_rootPath & "\hpdb.xml")
            Try
                bs_Categorys.Position = LastCategory
                bs_Categorys_Notes.Position = LastNote
            Catch ex As Exception
            End Try
        End If
    End Sub
    Private Sub WriteDB()
        If SaveorNot = True Then
            Ds_HelpDeskNotes.WriteXml(My.Settings.db_rootPath & "\hpdb.xml")
        End If
    End Sub
    Private Sub tsmi_Change_Path_Click(sender As Object, e As EventArgs) Handles tsmi_Change_Path.Click
        ChoosePath()
    End Sub
    Private Sub ChoosePath()
        Dim frm As New frm_ChoosePath
        frm.txtb_choosenPath.Text = My.Settings.db_rootPath
        Select Case frm.ShowDialog(Me)
            Case DialogResult.OK
                My.Settings.db_rootPath = frm.txtb_choosenPath.Text
                IO.Directory.CreateDirectory(My.Settings.db_rootPath & "\Additional")
                IO.Directory.CreateDirectory(My.Settings.db_rootPath & "\Additional\Pictures")
                IO.Directory.CreateDirectory(My.Settings.db_rootPath & "\Additional\Files")
                MessageBox.Show("New Path was choosen: " & Environment.NewLine & Environment.NewLine & My.Settings.db_rootPath)
                SaveorNot = True
                Ds_HelpDeskNotes.Clear()
                ReadDB()
            Case DialogResult.Cancel
                If My.Settings.db_rootPath <> "" Then
                    MessageBox.Show("No new Path was choosen, still using: " & Environment.NewLine & Environment.NewLine & My.Settings.db_rootPath)
                Else
                    MessageBox.Show("No Path was choosen. The Application can´t run without a Path." & Environment.NewLine & Environment.NewLine & "Application is now closing")
                    Close()
                End If
        End Select
    End Sub
    Private Sub tsmi_Add_Category_Click(sender As Object, e As EventArgs) Handles tsmi_Add_Category.Click
        Try
            Dim frm As New frm_CategoryName
            frm.bs_Categorys.DataSource = bs_Categorys.AddNew
            Select Case frm.ShowDialog(Me)
                Case DialogResult.OK
                    WriteDB()
                Case DialogResult.Cancel
                    bs_Categorys.RemoveCurrent()
                    WriteDB()
            End Select
        Catch ex As Exception
            MessageBox.Show(ex.ToString)
        End Try
    End Sub
    Private Sub tsmi_Edit_Category_Click(sender As Object, e As EventArgs) Handles tsmi_Edit_Category.Click
        If bs_Categorys.Count > 0 Then
            Try
                Dim frm As New frm_CategoryName
                frm.bs_Categorys.DataSource = bs_Categorys.Current
                Select Case frm.ShowDialog(Me)
                    Case DialogResult.OK
                        WriteDB()
                    Case DialogResult.Cancel
                        WriteDB()
                End Select
            Catch ex As Exception
                MessageBox.Show(ex.ToString)
            End Try
        Else
            MessageBox.Show("No entry available")
        End If
    End Sub
    Private Sub tsmi_DeleteCategory_Click(sender As Object, e As EventArgs) Handles tsmi_DeleteCategory.Click
        Try
            bs_Categorys.RemoveCurrent()
            WriteDB()
        Catch ex As Exception
            MessageBox.Show(ex.ToString)
        End Try
    End Sub
    Private Sub tsmi_Add_Note_Click(sender As Object, e As EventArgs) Handles tsmi_Add_Note.Click
        Try
            Dim frm As New frm_NoteCreationEdition
            frm.bs_Categorys_Notes.DataSource = bs_Categorys_Notes.AddNew
            Select Case frm.ShowDialog(Me)
                Case DialogResult.OK
                    WriteDB()
                Case DialogResult.Cancel
                    bs_Categorys.RemoveCurrent()
                    WriteDB()
            End Select
        Catch ex As Exception
            MessageBox.Show(ex.ToString)
        End Try
    End Sub
    Private Sub tsmi_Edit_Note_Click(sender As Object, e As EventArgs) Handles tsmi_Edit_Note.Click
        If bs_Categorys_Notes.Count > 0 Then
            Try
                Dim frm As New frm_NoteCreationEdition
                frm.bs_Categorys_Notes.DataSource = bs_Categorys_Notes.Current
                Select Case frm.ShowDialog(Me)
                    Case DialogResult.OK
                        WriteDB()
                    Case DialogResult.Cancel
                        WriteDB()
                End Select
            Catch ex As Exception
                MessageBox.Show(ex.ToString)
            End Try
        Else
            MessageBox.Show("No entry available")
        End If
    End Sub
    Private Sub tsmi_Delete_Note_Click(sender As Object, e As EventArgs) Handles tsmi_Delete_Note.Click
        Try
            bs_Categorys_Notes.RemoveCurrent()
            WriteDB()
        Catch ex As Exception
            MessageBox.Show(ex.ToString)
        End Try
    End Sub
    Private Sub btn_DetailView_Click(sender As Object, e As EventArgs) Handles btn_DetailView.Click
        If bs_Categorys.Count > 0 Then
            If bs_Categorys_Notes.Count > 0 Then
                Try
                    Dim frm As New frm_DetailView
                    frm.bs_Categorys_Notes.DataSource = bs_Categorys_Notes.Current
                    frm.ShowDialog(Me)
                Catch ex As Exception
                    MessageBox.Show(ex.ToString)
                End Try
            Else
                MessageBox.Show("No entry available")
            End If
        End If
    End Sub
    Private Sub tsmi_AllowEdit_Click(sender As Object, e As EventArgs) Handles tsmi_AllowEdit.Click
        Dim workstate As String = My.Settings.db_rootPath & "\working.txt"
        If tsmi_AllowEdit.Text = "Allow Edit" Then
            If Not File.Exists(workstate) Then
                File.Create(workstate).Dispose()
                ReadDB()
                tsmi_Edit_Entrys.Visible = True
                tsmi_AllowEdit.Text = "Disable Edit"
                SaveorNot = True
            Else
                MessageBox.Show("Someone is already working on the Database")
            End If
        Else
            File.Delete(workstate)
            tsmi_Edit_Entrys.Visible = False
            tsmi_AllowEdit.Text = "Allow Edit"
            ReadDB()
        End If
    End Sub
    Private Sub txtb_CategoryFilter_TextChanged(sender As Object, e As EventArgs) Handles txtb_CategoryFilter.TextChanged
        If txtb_CategoryFilter.Text <> "" Then
            bs_Categorys.Filter = String.Format("CategoryName LIKE '%{0}%' ", txtb_CategoryFilter.Text)
        Else
            bs_Categorys.Filter = ""
        End If
    End Sub
    Private Sub txtb_NoteFilter_TextChanged(sender As Object, e As EventArgs) Handles txtb_NoteFilter.TextChanged
        If txtb_NoteFilter.Text <> "" Then
            bs_Categorys_Notes.Filter = String.Format("NoteName LIKE '%{0}%' ", txtb_NoteFilter.Text)
        Else
            bs_Categorys_Notes.Filter = ""
        End If
    End Sub
    Private Sub tsmi_RefreshDB_Click(sender As Object, e As EventArgs) Handles tsmi_RefreshDB.Click
        ReadDB()
    End Sub

    Private Sub tsmi_Notepad_Click(sender As Object, e As EventArgs) Handles tsmi_Notepad.Click
        Process.Start("notepad.exe")
    End Sub


    Private Sub ctsmi_Copy_Click(sender As Object, e As EventArgs) Handles ctsmi_Copy.Click
        Try
            Dim t As TextBoxBase = CType(LastTextField, TextBoxBase)
            Clipboard.SetText(t.SelectedText)
        Catch ex As Exception
        End Try
    End Sub
    Private Sub ctsmi_Paste_Click(sender As Object, e As EventArgs) Handles ctsmi_Paste.Click
        Try
            Dim t As TextBoxBase = CType(LastTextField, TextBoxBase)
            t.SelectedText = Clipboard.GetText
        Catch ex As Exception
        End Try
    End Sub

    Private Sub cms_CopyPaste_Opening(sender As Object, e As CancelEventArgs) Handles cms_CopyPaste.Opening
        If cms_CopyPaste.SourceControl.Name = "rtb_NoteText" Then
            ctsmi_Paste.Visible = False
        Else
            ctsmi_Paste.Visible = True
        End If

        LastTextField = DirectCast(cms_CopyPaste.SourceControl, TextBox)
    End Sub
End Class